{% macro render(post, from_index=false, from_sidebar=false, from_feed=false, nth=0) -%}
{% import "macros/author.html" as author %}
  <article class="blog-post">
    {%- if from_index or from_sidebar %}
      <h2 class="title">
        <a href="{{ post|url }}">{{ post.title }}</a>
      </h2>
    {%- elif not from_feed %}
      <h1 class="title">
        {{ post.title }}
      </h1>
    {%- endif %}
    {%- if not from_feed %}
    <p class="meta">
      by {{ author.render(post) }} | {{ post.pub_date.strftime('%B %-d, %Y') }}
    </p>
    {%- endif %}
  {%- if not from_sidebar %}
    {%- if from_index %}
      {%- if post.pub_date > default_image_cutoff -%}
    <a href="{{ post|url }}">
      <picture>
        {{ image_sources(post) }}
        <img class="lead" {% if nth > 3 %}loading="lazy" {% endif %}src="{{ image_url(post) }}">
      </picture>
    </a>
      {%- elif image_url(post, fallback=false) -%}
    <picture>
      {{ image_sources(post, fallback=false) }}
      <img class="lead" {% if nth > 3 %}loading="lazy" {% endif %}src="{{ image_url(post) }}">
    </picture>
      {%- endif -%}
    {%- elif from_feed %}
    <picture>
      {{ image_sources(post, external=True) }}
      <img class="lead" referrerpolicy="no-referrer" loading="lazy" src="{{ image_url(post, external=True) }}">
    </picture>
    {%- else %}
    <picture>
      {{ image_sources(post) }}
      <img class="lead" src="{{ image_url(post) }}">
    </picture>
    {%- endif %}
  {%- endif %}
  {%- if from_index or from_sidebar %}
    {{- render_summary(post) }}
  {%- else %}
    <div class="body">
  {%-   if post.body %}
      {%- if post.guest_author -%}
      <em>This is a guest post by {{ post.guest_author }}.</em>
      {%- endif -%}
      {{ post.body }}
  {%-   else %}
      <link rel="stylesheet" href="{{ '/static/css/legacy.css'|asseturl }}">
      {{ post._html_body }}
  {%-   endif %}
    </div>
  {%- endif -%}
  {%- if post.categories and not from_sidebar %}
  <div class="categories">
    <ul>
      {%- for t in post.categories -%}
      <li>
        <a href="{{ ('/category/' ~ t|slug)|url }}">
          {{ t }}
        </a>
      </li>
      {%- endfor -%}
    </ul>
  </div>
  {%- endif %}
  </article>
{% endmacro %}

{% macro image_url(post, external=False, fallback=True) -%}
{% if post.attachments.images.get('lead.png') -%}
{%   set image = post.attachments.images.get('lead.png') -%}
{% elif post.attachments.images.get('lead.jpg') -%}
{%   set image = post.attachments.images.get('lead.jpg') -%}
{% elif post.attachments.images.get('lead.gif') -%}
{%   set image = post.attachments.images.get('lead.gif') -%}
{% elif fallback -%}
{%   set image = '/static/images/lead.png' -%}
{% endif -%}
{% if image and external -%}
{{   url_to(image, external=True) -}}
{% elif image -%}
{{   url_to(image) -}}
{% endif -%}
{% endmacro %}

{% macro image_sources(post, external=False, fallback=True) -%}
{%- if fallback and not post.attachments.images.get('lead.png') and not post.attachments.images.get('lead.jpg') and not post.attachments.images.get('lead.gif') -%}
<source media="(min-width:415px)" srcset="{{ url_to('/static/images/lead.webp', external=external) }}" type="image/webp">
<source srcset="{{ url_to('/static/images/lead_small.webp', external=external) }}" type="image/webp">
{% else -%}
{% if post.attachments.get('lead.webp') -%}
<source media="(min-width:415px)" srcset="{{ url_to(post.attachments.get('lead.webp'), external=external) }}" type="image/webp">
{% endif -%}
{% if post.attachments.get('lead_small.webp') -%}
<source srcset="{{ url_to(post.attachments.get('lead_small.webp'), external=external) }}" type="image/webp">
{% endif -%}
{% endif -%}
{% endmacro %}

{% macro render_summary(post) -%}
    {%- if post.summary %}
      {{ post.summary }}
    {%- elif post._html_body.find("<!--break-->") > -1  %}
      {{ post._html_body.split("<!--break-->")[0] }}
    {%- elif post.body %}
      {{ post.body|truncate(100) }}
    {%- else %}
      <p>{{ post._html_body|striptags|truncate(100) }}</p>
    {%- endif %}
{% endmacro %}
